<section class="partial">
    <section>
        <h2>&#x1F40E; Performance &#x1F40E;</h2>
        <h4 class="fragment">Pas de balle en argent &#x1F52B;</h4>
        <h4 class="fragment">Ne mettez les mains dedans que si nécessaire &#x1F64C;</h4>
        <aside class="notes">
            Car à partir de maintenant vous allez basculer dans un autre monde...
        </aside>
    </section>

    <section>
        <h2>&#x1F4C8; Processus IO &#x1F4C8;</h2>
        <ul>
            <li class="fragment small">Au travers de libuv</li>
            <li class="fragment small">Tous les appels IO et callbacks</li>
            <li class="fragment small">Thread pool de 4 par défaut</li>
            <li class="fragment small">Appel au système majoritairement non bloquant</li>
            <li class="fragment small">Bloquant sur opérations FS, DNS et quelques drivers (base de données...)</li>
            <li class="fragment small">
                Configurable avec <code>UV_THREADPOOL_SIZE</code><br>
                (<img src="../img/warning.png" class="icon baseline" /> requêtes lentes ne sera pas une solution)
            </li>
        </ul>
        <aside class="notes">
            N'y allez que si vous avez testé qu'il y avait un réel gain.<br>
            Nous avons eu le cas avec des spawn d'utilitaires (de 1 à 10) bloquants qu'on ne pouvait lancer que 4 par 4 : monter le thread pool à 8 a divisé les temps d'exécution par 2,5
        </aside>
    </section>

    <section>
        <h2>&#x1F35C; Compilation V8 &#x1F35C;</h2>
        <ul>
            <li class="fragment small">Javascript en code machine</li>
            <li class="fragment small">Démarrage non-optimisé puis pré-chauffage et optimisation (Crankshaft / Turbofan)</li>
            <li class="fragment small">JIT initial très rapide (aucun type connu) puis il va les découvrir</li>
            <li class="fragment small">Inline Caches (IC) avec des perfs x20</li>
            <li class="fragment small">Génère un <em>Stub</em> hyper-optimisé et réutilisable (court-circuit) selon le type du paramètre.</li>
            <li class="fragment small">Type avec une <em>Hidden Class</em></li>
        </ul>
    </section>

    <section>
        <h2>&#x1F47B; Hidden Class &#x1F47B;</h2>
        <pre><code>
    function Point(x, y) {
      this.x = x; // => hidden Point1 class created
      this.y = y; // => hidden Point2 class created
    }

    var p1 = new Point(1, 2); // => hidden Point0 class created
    var p2 = new Point(3, 4); // => hidden Point2 is reused

    // ....

    p1.z = 3; // => another hidden class Point3 created
        </code></pre>
    </section>

    <section>
        <h2>&#x1F366; Optimisations &#x1F366;</h2>
        <ul>
            <li class="fragment small">Privilégier des fonctions monomorphiques (même <em>Hidden Class</em> en entrée)</li>
            <li class="fragment small">Poly|Méga-morphique quasi non-optimisable</li>
            <li class="fragment small">Éviter les modifications de <em>Hidden Class</em></li>
            <li class="fragment small">Et ce n'est qu'un exemple de ce que fait V8 !</li>
            <li class="fragment small">N'oubliez jamais : <em>l'optimisation prématurée est la source de tous les maux</em></li>
            <li class="fragment small">Je ne vous demande pas de tester <code>void 0</code> au lieu de <code>undefined</code> ou de faire une <code>for-loop</code> au lieu de <code>forEach</code> &#x1F609;</li>
        </ul>
        <aside class="notes">
            Une ligne par gc.<br>
            Une ligne par gc avec du détail.<br>
            Nombre d'objets et occupation mémoire.<br>
            Statistique du Inline Caches.
        </aside>
    </section>

    <section>
        <h2>&#x1F4CA; Analyse du gain &#x1F4CA;</h2>
        <ul class="fragment">
            <li class="small"><code>node --v8-options | grep trace</code> <img src="../img/bulb.png" class="icon bulb" /></li>
            <li class="small"><code>--trace_gc</code></li>
            <li class="small"><code>--trace_gc_verbose</code></li>
            <li class="small"><code>--trace_gc_object_stats</code></li>
            <li class="small"><code>--trace_ic</code></li>
            <li class="small"><code>--trace-opt</code></li>
            <li class="small"><code>--trace-deopt</code></li>
        </ul>
        <aside class="notes">
            Une ligne par gc.<br>
            Une ligne par gc avec du détail.<br>
            Nombre d'objets et occupation mémoire.<br>
            Statistique du Inline Caches.
        </aside>
    </section>

    <section>
        <h2>&#x1F3C3; Fuites mémoires &#x1F3C3;</h2>
        <ul>
            <li class="fragment">Référence sur le root node (global...) = pas libérable par le GC !</li>
            <li class="fragment">Évènement (EventEmitter...) positionné sur un objet = pas libérable par le GC !</li>
            <li class="fragment">Comparaison de captures de la heap &#x1F3C6;</li>
        </ul>
    </section>

    <section>
        <h2>&#x1F680; Cluster (natif) &#x1F680;</h2>
        <pre><code>
import cluster from 'cluster';
import express from 'express';

const numCPUs = require('os').cpus().length;

if (cluster.isMaster) {
    for (var i = 0; i < numCPUs; i++) cluster.fork();
} else {
    // Workers share the TCP connection in this server
    var app = express();

    app.get('/', (req, res) => res.send('Hello World!'));

    // All workers use this port
    app.listen(8080);
}
        </code></pre>
        <aside class="notes">
            Cluster en node sinon plusieurs instances node spérarées et un LB devant.
        </aside>
    </section>

    <section>
        <h2 class="small">
            &#x1F4D0; Patron de conception  &#x1F4D0;<br>
            pour l'asynchrone
        </h2>
        <ul>
            <li class="fragment">Streams</li>
            <li class="fragment">Asynchronous request batching / caching</li>
        </ul>
    </section>

    <section>
        <h2 class="very-small">
            &#x1F69A; Asynchronous request &#x1F69A;<br>
            batching / caching
        </h2>
        <pre style="font-size: 0.5em"><code>
  const heavyProcess = require('./heavy-process');
  const queue = new Map();

  module.exports = function myBatch(body, callback) {
    if (queue.has(body)) {
      queue.get(body).push(callback); // Batch (3)
      return;
    }

    queue.set(body, [callback]); // Init queue (1)

    heavyProcess(body, (err, res) => { // Process (2)
      const queue = queue.get(body);
      queue.delete(body);
      queue.forEach(cb => cb(err, res)); // Unbatch (4)
    });
  };
        </code></pre>
    </section>
</section>
